Package ghidra.util

# Class HashingOutputStream

java.lang.Object
java.io.OutputStream
ghidra.util.HashingOutputStream

All Implemented Interfaces:
  `Closeable`, `Flushable`, `AutoCloseable`

public class HashingOutputStream extends OutputStream
A filtering `OutputStream` that calculates the hash of the bytes being written.

Call `getDigest()` to retrieve the hash value bytes.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `HashingOutputStream(OutputStream out, String hashAlgo)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `close()`
  `void`
  `flush()`
  `byte[]`
  `getDigest()`
  `void`
  `write(byte[] b)`
  `void`
  `write(byte[] b, int off, int len)`
  `void`
  `write(int b)`

  ### Methods inherited from class java.io.OutputStream

  `nullOutputStream`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### HashingOutputStream

    public HashingOutputStream(OutputStream out, String hashAlgo) throws NoSuchAlgorithmException
    Parameters:
      `out` - - OutputStream to wrap
      `hashAlgo` - - see `MessageDigest.getInstance(String)`, ie. "MD5".
    Throws:
      `NoSuchAlgorithmException`

- ## Method Details

  - ### write

    public void write(int b) throws IOException
    Specified by:
      `write` in class `OutputStream`
    Throws:
      `IOException`

  - ### write

    public void write(byte[] b) throws IOException
    Overrides:
      `write` in class `OutputStream`
    Throws:
      `IOException`

  - ### write

    public void write(byte[] b, int off, int len) throws IOException
    Overrides:
      `write` in class `OutputStream`
    Throws:
      `IOException`

  - ### flush

    public void flush() throws IOException
    Specified by:
      `flush` in interface `Flushable`
    Overrides:
      `flush` in class `OutputStream`
    Throws:
      `IOException`

  - ### close

    public void close() throws IOException
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Overrides:
      `close` in class `OutputStream`
    Throws:
      `IOException`

  - ### getDigest

    public byte[] getDigest()